unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, Grids, DBGrids, DBClient, StdCtrls, Spin;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    ClientDataSet1Field1: TStringField;
    ClientDataSet1Field2: TStringField;
    ClientDataSet1Field3: TStringField;
    ClientDataSet1Field4: TStringField;
    ClientDataSet1Integer1: TIntegerField;
    ClientDataSet1Integer2: TIntegerField;
    Button2: TButton;
    Edit1: TEdit;
    Button3: TButton;
    SpinEdit1: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  SuccessCreate : Boolean = True;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  I,Rec : Integer;
begin
  ClientDataSet1.Close;
  ClientDataSet1.CreateDataSet;
  Randomize;
  Rec := Random(10) + 5;
  for I := 1 to Rec do
    begin
      with ClientDataSet1 do
        begin
          Append;
          FieldByName('Field1').AsString := 'Field1'+ FormatFloat('000',I);
          FieldByName('Field2').AsString := 'Field2'+ FormatFloat('000',I);
          FieldByName('Field3').AsString := 'Field3'+ FormatFloat('000',I);
          FieldByName('Field4').AsString := 'Field4'+ FormatFloat('000',I);
          FieldByName('Integer1').AsInteger := Random(1000);
          FieldByName('Integer2').AsInteger := Random(1000);
          Post;
        end;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
Var
    FS : TFileStream;
    I : integer;
begin
  IF FileExists(Self.Name + '.res') THEN
    BEGIN
      FS := TFileStream.Create(Self.Name + '.res',fmOpenRead);
      TRY
        FOR I := 0 TO ComponentCount - 1 DO
          BEGIN
            TRY
              FS.ReadComponentRes(Components[i]);
            EXCEPT
                SuccessCreate := False;
            END;
          END;
      FINALLY
        FS.Free;
        SuccessCreate := False;
      END;
    END;
end;

procedure TForm1.FormDestroy(Sender: TObject);
Var
  FS : TFileStream;
  I : Integer;
begin
  IF SuccessCreate THEN
    BEGIN
      FS := TFileStream.Create(Self.Name + '.res', fmCreate);
        TRY
          FOR I := 0 TO ComponentCount - 1 DO
            FS.WriteComponentRes(Components[i].Name, Components[i]);
        FINALLY
           FS.Free;
        END;
    END
  ELSE
    BEGIN
      IF FileExists(Self.Name + '.res') THEN
        DeleteFile(Self.Name + '.res');
    END;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  SuccessCreate := False;
  Showmessage('Done !! Please restart the program.');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  try
    DBGrid1.Columns.Items[SpinEdit1.Value].Title.Caption := Edit1.Text;
  except
  end;
end;

end.
